-- Example from program specialization
-- double_even

-- ******Original program 
-- 
-- data nat = Z | S nat 
-- 
-- double :: nat -> nat
-- double Z     = Z
-- double (S x) = S (S (double x))
-- 
-- even :: nat -> Bool
-- even Z         = True
-- even (S Z)     = False
-- even (S (S x)) = even x

-- ******Specialized for goal: even (double x)

-- ******Specialized program 

data nat = Z | S nat 

even_pe :: nat -> Bool
even_pe Z = True
even_pe (S x) = even_pe x

-- ******After analysis and erasure:
-- 
-- data nat = Z | S nat 
-- 
-- even_pe :: Bool
-- even_pe = True
