-- Example from program specialization
-- plus_minus

-- ******Original program 
-- 
-- data nat = Z | S nat 
-- 
-- plus :: nat -> nat -> nat
-- plus Z     x = x
-- plus (S x) y = S (plus x y)
-- 
-- minus :: nat -> nat -> nat
-- minus x     Z     = x
-- minus (S x) (S y) = minus(X,Y)

-- ******Specialized for goal: minus (plus x y) x

-- ******Specialized program 

data nat = Z | S nat 

minus_pe :: nat -> nat -> nat
minus_pe Z     y = y
minus_pe (S x) y = minus_pe x y

-- ******After analysis and erasure:
-- 
-- data nat = Z | S nat 
-- 
-- minus_pe :: nat -> nat
-- minus_pe y = y
