-- Example from program specialization
-- minimal_append

-- ******Original program 
-- 
-- data nat = Z | S nat 
-- 
-- min :: nat -> nat -> nat
-- min Z     x     = Z
-- min (S x) Z     = Z
-- min (S x) (S y) = S (min x y)
-- 
-- minimal :: [nat] -> nat
-- minimal (x:[])   = x
-- minimal (x:y:xs) = min x (minimal (y:xs))
-- 
-- append :: [Nat] -> [Nat] -> [Nat]
-- append []     y = y
-- append (x:xs) y = x:(append xs y)

-- ******Specialized for goal: minimal (append (Z:[]) xs)

-- ******Specialized program 

data nat = Z | S nat 

minimal_pe :: [nat] -> nat
minimal_pe []  = Z
minimal_pe (x:y) = Z

-- ******After analysis and erasure:
-- 
-- data nat = Z | S nat 
-- 
-- minimal_pe :: nat
-- minimal_pe = Z
