---------------------------------------------------------
-- Example of redundant arguments
--   Extracted from
--   T. Arts and J. Giesl.
--   A collection of examples for termination of 
--   term rewriting using dependency pairs.
--   Technical Report AIB-2001-09 RWTH Aachen, 2001. 
--   (Example 2.23)
---------------------------------------------------------

data nat = Z | S nat

f :: nat -> nat -> nat
f Z     y = Z
f (S x) y = f (f x y) y

-- After analysis and erasure:
-- 
-- data nat = Z | S nat
-- 
-- f :: nat
-- f = Z

